feat(infra): Add 1n_spr
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2023 Cisco and/or its affiliates.
2 # Copyright (c) 2023 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2" | "1n_spr")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96 }
97
98
99 function activate_virtualenv () {
100
101     # Update virtualenv pip package, delete and create virtualenv directory,
102     # activate the virtualenv, install requirements, set PYTHONPATH.
103
104     # Arguments:
105     # - ${1} - Path to existing directory for creating virtualenv in.
106     #          If missing or empty, ${CSIT_DIR} is used.
107     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
108     # Variables read:
109     # - CSIT_DIR - Path to existing root of local CSIT git repository.
110     # Variables exported:
111     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
112     # Functions called:
113     # - die - Print to stderr and exit.
114
115     set -exuo pipefail
116
117     root_path="${1-$CSIT_DIR}"
118     env_dir="${root_path}/env"
119     req_path=${2-$CSIT_DIR/requirements.txt}
120     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
121     pip3 install virtualenv==20.15.1 || {
122         die "Virtualenv package install failed."
123     }
124     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
125         die "Virtualenv creation for $(which python3) failed."
126     }
127     set +u
128     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
129     set -u
130     pip3 install -r "${req_path}" || {
131         die "Requirements installation failed."
132     }
133     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
134     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
135 }
136
137
138 function archive_tests () {
139
140     # Create .tar.gz of generated/tests for archiving.
141     # To be run after generate_tests, kept separate to offer more flexibility.
142
143     # Directory read:
144     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
145     # File rewriten:
146     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
147
148     set -exuo pipefail
149
150     pushd "${ARCHIVE_DIR}" || die
151     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
152     popd || die
153 }
154
155
156 function check_download_dir () {
157
158     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
159     #
160     # Variables read:
161     # - DOWNLOAD_DIR - Path to directory robot takes the build to test from.
162     # Directories read:
163     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
164     # Functions called:
165     # - die - Print to stderr and exit.
166
167     set -exuo pipefail
168
169     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
170         die "No artifacts downloaded!"
171     fi
172 }
173
174
175 function check_prerequisites () {
176
177     # Fail if prerequisites are not met.
178     #
179     # Functions called:
180     # - installed - Check if application is installed/present in system.
181     # - die - Print to stderr and exit.
182
183     set -exuo pipefail
184
185     if ! installed sshpass; then
186         die "Please install sshpass before continue!"
187     fi
188 }
189
190
191 function common_dirs () {
192
193     # Set global variables, create some directories (without touching content).
194
195     # Variables set:
196     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
197     # - CSIT_DIR - Path to existing root of local CSIT git repository.
198     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
199     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
200     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
201     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
202     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
203     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
204     #   The name is chosen to match what ci-management expects.
205     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
206     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
207     # Directories created if not present:
208     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
209     # Functions called:
210     # - die - Print to stderr and exit.
211
212     set -exuo pipefail
213
214     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
215         die "Some error during locating of this source file."
216     }
217     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
218         die "Some error during dirname call."
219     }
220     # Current working directory could be in a different repo, e.g. VPP.
221     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
222     relative_csit_dir=$(git rev-parse --show-toplevel) || {
223         die "Git rev-parse failed."
224     }
225     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
226     popd || die "Popd failed."
227     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
228         die "Readlink failed."
229     }
230     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/resources/job_specs") || {
231         die "Readlink failed."
232     }
233     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
234         die "Readlink failed."
235     }
236     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_robot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
267     # Variables set:
268     # - ROBOT_ARGS - String holding part of all arguments for robot.
269     # - EXPANDED_TAGS - Array of strings robot arguments compiled from tags.
270
271     set -exuo pipefail
272
273     # No explicit check needed with "set -u".
274     ROBOT_ARGS=("--loglevel" "TRACE")
275     ROBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
276
277     case "${TEST_CODE}" in
278         *"device"*)
279             ROBOT_ARGS+=("--suite" "tests.${DUT}.device")
280             ;;
281         *"perf"*)
282             ROBOT_ARGS+=("--suite" "tests.${DUT}.perf")
283             ;;
284         *)
285             die "Unknown specification: ${TEST_CODE}"
286     esac
287
288     EXPANDED_TAGS=()
289     for tag in "${TAGS[@]}"; do
290         if [[ ${tag} == "!"* ]]; then
291             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
292         else
293             if [[ ${SELECTION_MODE} == "--test" ]]; then
294                 EXPANDED_TAGS+=("--test" "${tag}")
295             else
296                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
297             fi
298         fi
299     done
300
301     if [[ ${SELECTION_MODE} == "--test" ]]; then
302         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
303     fi
304 }
305
306
307 function deactivate_docker_topology () {
308
309     # Deactivate virtual vpp-device topology by removing containers.
310     #
311     # Variables read:
312     # - NODENESS - Node multiplicity of desired testbed.
313     # - FLAVOR - Node flavor string, usually describing the processor.
314
315     set -exuo pipefail
316
317     case_text="${NODENESS}_${FLAVOR}"
318     case "${case_text}" in
319         "1n_skx" | "1n_tx2" | "1n_spr")
320             ssh="ssh root@172.17.0.1 -p 6022"
321             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
322             # The "declare -f" output is long and boring.
323             set +x
324             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
325                 die "Topology cleanup via shim-dcr failed!"
326             }
327             set -x
328             ;;
329         "1n_vbox")
330             enter_mutex || die
331             clean_environment || {
332                 die "Topology cleanup locally failed!"
333             }
334             exit_mutex || die
335             ;;
336         *)
337             die "Unknown specification: ${case_text}!"
338     esac
339 }
340
341
342 function die () {
343
344     # Print the message to standard error end exit with error code specified
345     # by the second argument.
346     #
347     # Hardcoded values:
348     # - The default error message.
349     # Arguments:
350     # - ${1} - The whole error message, be sure to quote. Optional
351     # - ${2} - the code to exit with, default: 1.
352
353     set -x
354     set +eu
355     warn "${1:-Unspecified run-time error occurred!}"
356     exit "${2:-1}"
357 }
358
359
360 function die_on_robot_error () {
361
362     # Source this fragment if you want to abort on any failed test case.
363     #
364     # Variables read:
365     # - ROBOT_EXIT_STATUS - Set by a robot running fragment.
366     # Functions called:
367     # - die - Print to stderr and exit.
368
369     set -exuo pipefail
370
371     if [[ "${ROBOT_EXIT_STATUS}" != "0" ]]; then
372         die "Test failures are present!" "${ROBOT_EXIT_STATUS}"
373     fi
374 }
375
376
377 function generate_tests () {
378
379     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
380     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
381     # The generation is done by executing any *.py executable
382     # within any subdirectory after copying.
383
384     # This is a separate function, because this code is called
385     # both by autogen checker and entries calling run_robot.
386
387     # Directories read:
388     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
389     # Directories replaced:
390     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
391
392     set -exuo pipefail
393
394     rm -rf "${GENERATED_DIR}/tests" || die
395     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
396     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
397     cmd_line+=("-executable" "-name" "*.py")
398     # We sort the directories, so log output can be compared between runs.
399     file_list=$("${cmd_line[@]}" | sort) || die
400
401     for gen in ${file_list}; do
402         directory="$(dirname "${gen}")" || die
403         filename="$(basename "${gen}")" || die
404         pushd "${directory}" || die
405         ./"${filename}" || die
406         popd || die
407     done
408 }
409
410
411 function get_test_code () {
412
413     # Arguments:
414     # - ${1} - Optional, argument of entry script (or empty as unset).
415     #   Test code value to override job name from environment.
416     # Variables read:
417     # - JOB_NAME - String affecting test selection, default if not argument.
418     # Variables set:
419     # - TEST_CODE - The test selection string from environment or argument.
420     # - NODENESS - Node multiplicity of desired testbed.
421     # - FLAVOR - Node flavor string, usually describing the processor.
422
423     set -exuo pipefail
424
425     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
426     if [[ -z "${TEST_CODE}" ]]; then
427         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
428     fi
429
430     case "${TEST_CODE}" in
431         *"1n-vbox"*)
432             NODENESS="1n"
433             FLAVOR="vbox"
434             ;;
435         *"1n-skx"*)
436             NODENESS="1n"
437             FLAVOR="skx"
438             ;;
439         *"1n-spr"*)
440             NODENESS="1n"
441             FLAVOR="spr"
442             ;;
443         *"1n-tx2"*)
444             NODENESS="1n"
445             FLAVOR="tx2"
446             ;;
447         *"1n-aws"*)
448             NODENESS="1n"
449             FLAVOR="aws"
450             ;;
451         *"2n-aws"*)
452             NODENESS="2n"
453             FLAVOR="aws"
454             ;;
455         *"3n-aws"*)
456             NODENESS="3n"
457             FLAVOR="aws"
458             ;;
459         *"1n-c6gn"*)
460             NODENESS="1n"
461             FLAVOR="c6gn"
462             ;;
463         *"2n-c6gn"*)
464             NODENESS="2n"
465             FLAVOR="c6gn"
466             ;;
467         *"3n-c6gn"*)
468             NODENESS="3n"
469             FLAVOR="c6gn"
470             ;;
471         *"1n-c6in"*)
472             NODENESS="1n"
473             FLAVOR="c6in"
474             ;;
475         *"2n-c6in"*)
476             NODENESS="2n"
477             FLAVOR="c6in"
478             ;;
479         *"3n-c6in"*)
480             NODENESS="3n"
481             FLAVOR="c6in"
482             ;;
483         *"2n-zn2"*)
484             NODENESS="2n"
485             FLAVOR="zn2"
486             ;;
487         *"2n-clx"*)
488             NODENESS="2n"
489             FLAVOR="clx"
490             ;;
491         *"2n-icx"*)
492             NODENESS="2n"
493             FLAVOR="icx"
494             ;;
495         *"2n-spr"*)
496             NODENESS="2n"
497             FLAVOR="spr"
498             ;;
499         *"3n-icx"*)
500             NODENESS="3n"
501             FLAVOR="icx"
502             ;;
503         *"3na-spr"*)
504             NODENESS="3na"
505             FLAVOR="spr"
506             ;;
507         *"3nb-spr"*)
508             NODENESS="3nb"
509             FLAVOR="spr"
510             ;;
511         *"3n-snr"*)
512             NODENESS="3n"
513             FLAVOR="snr"
514             ;;
515         *"2n-tx2"*)
516             NODENESS="2n"
517             FLAVOR="tx2"
518             ;;
519         *"3n-tsh"*)
520             NODENESS="3n"
521             FLAVOR="tsh"
522             ;;
523         *"3n-alt"*)
524             NODENESS="3n"
525             FLAVOR="alt"
526             ;;
527     esac
528 }
529
530
531 function get_test_tag_string () {
532
533     # Variables read:
534     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
535     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
536     # - TEST_CODE - The test selection string from environment or argument.
537     # Variables set:
538     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
539     #   May be empty, or even not set on event types not adding comment.
540     # Variables exported optionally:
541     # - GRAPH_NODE_VARIANT - Node variant to test with, set if found in trigger.
542
543     # TODO: ci-management scripts no longer need to perform this.
544
545     set -exuo pipefail
546
547     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
548         case "${TEST_CODE}" in
549             *"device"*)
550                 trigger="devicetest"
551                 ;;
552             *"perf"*)
553                 trigger="perftest"
554                 ;;
555             *)
556                 die "Unknown specification: ${TEST_CODE}"
557         esac
558         # Ignore lines not containing the trigger word.
559         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
560         # The vpp-csit triggers trail stuff we are not interested in.
561         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
562         # (except relying on \s whitespace, \S non-whitespace and . both).
563         # The last string is concatenated, only the middle part is expanded.
564         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
565         # On parsing error, TEST_TAG_STRING probably stays empty.
566         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
567         if [[ -z "${TEST_TAG_STRING-}" ]]; then
568             # Probably we got a base64 encoded comment.
569             comment="${GERRIT_EVENT_COMMENT_TEXT}"
570             comment=$(base64 --decode <<< "${comment}" || true)
571             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
572             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
573         fi
574         if [[ -n "${TEST_TAG_STRING-}" ]]; then
575             test_tag_array=(${TEST_TAG_STRING})
576             if [[ "${test_tag_array[0]}" == "icl" ]]; then
577                 export GRAPH_NODE_VARIANT="icl"
578                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
579             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
580                 export GRAPH_NODE_VARIANT="skx"
581                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
582             fi
583         fi
584     fi
585 }
586
587
588 function installed () {
589
590     # Check if the given utility is installed. Fail if not installed.
591     #
592     # Duplicate of common.sh function, as this file is also used standalone.
593     #
594     # Arguments:
595     # - ${1} - Utility to check.
596     # Returns:
597     # - 0 - If command is installed.
598     # - 1 - If command is not installed.
599
600     set -exuo pipefail
601
602     command -v "${1}"
603 }
604
605
606 function move_archives () {
607
608     # Move archive directory to top of workspace, if not already there.
609     #
610     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
611     # but in some jobs CSIT_DIR is not same as WORKSPACE
612     # (e.g. under VPP_DIR). To simplify ci-management settings,
613     # we want to move the data to the top. We do not want simple copy,
614     # as ci-management is eager with recursive search.
615     #
616     # As some scripts may call this function multiple times,
617     # the actual implementation use copying and deletion,
618     # so the workspace gets "union" of contents (except overwrites on conflict).
619     # The consequence is empty ARCHIVE_DIR remaining after this call.
620     #
621     # As the source directory is emptied,
622     # the check for dirs being different is essential.
623     #
624     # Variables read:
625     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
626     #   Can be unset, then it speeds up manual testing.
627     # - ARCHIVE_DIR - Path to directory with content to be moved.
628     # Directories updated:
629     # - ${WORKSPACE}/archives/ - Created if does not exist.
630     #   Content of ${ARCHIVE_DIR}/ is moved.
631     # Functions called:
632     # - die - Print to stderr and exit.
633
634     set -exuo pipefail
635
636     if [[ -n "${WORKSPACE-}" ]]; then
637         target=$(readlink -f "${WORKSPACE}/archives")
638         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
639             mkdir -p "${target}" || die "Archives dir create failed."
640             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
641             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
642         fi
643     fi
644 }
645
646
647 function prepare_topology () {
648
649     # Prepare virtual testbed topology if needed based on flavor.
650
651     # Variables read:
652     # - TEST_CODE - String affecting test selection, usually jenkins job name.
653     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
654     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
655     # Variables set:
656     # - TERRAFORM_MODULE_DIR - Terraform module directory.
657     # Functions called:
658     # - die - Print to stderr and exit.
659     # - terraform_init - Terraform init topology.
660     # - terraform_apply - Terraform apply topology.
661
662     set -exuo pipefail
663
664     case_text="${NODENESS}_${FLAVOR}"
665     case "${case_text}" in
666         "1n_aws" | "2n_aws" | "3n_aws")
667             export TF_VAR_testbed_name="${TEST_CODE}"
668             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
669             terraform_init || die "Failed to call terraform init."
670             trap "terraform_destroy" ERR EXIT || {
671                 die "Trap attempt failed, please cleanup manually. Aborting!"
672             }
673             terraform_apply || die "Failed to call terraform apply."
674             ;;
675         "1n_c6gn" | "2n_c6gn" | "3n_c6gn")
676             export TF_VAR_testbed_name="${TEST_CODE}"
677             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6gn"
678             terraform_init || die "Failed to call terraform init."
679             trap "terraform_destroy" ERR EXIT || {
680                 die "Trap attempt failed, please cleanup manually. Aborting!"
681             }
682             terraform_apply || die "Failed to call terraform apply."
683             ;;
684         "1n_c6in" | "2n_c6in" | "3n_c6in")
685             export TF_VAR_testbed_name="${TEST_CODE}"
686             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6in"
687             terraform_init || die "Failed to call terraform init."
688             trap "terraform_destroy" ERR EXIT || {
689                 die "Trap attempt failed, please cleanup manually. Aborting!"
690             }
691             terraform_apply || die "Failed to call terraform apply."
692             ;;
693     esac
694 }
695
696
697 function reserve_and_cleanup_testbed () {
698
699     # Reserve physical testbed, perform cleanup, register trap to unreserve.
700     # When cleanup fails, remove from topologies and keep retrying
701     # until all topologies are removed.
702     #
703     # Variables read:
704     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
705     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
706     # - BUILD_TAG - Any string suitable as filename, identifying
707     #   test run executing this function. May be unset.
708     # Variables set:
709     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
710     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
711     # Functions called:
712     # - die - Print to stderr and exit.
713     # - ansible_playbook - Perform an action using ansible, see ansible.sh
714     # Traps registered:
715     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
716
717     set -exuo pipefail
718
719     while true; do
720         for topo in "${TOPOLOGIES[@]}"; do
721             set +e
722             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
723             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
724             python3 "${scrpt}" "${opts[@]}"
725             result="$?"
726             set -e
727             if [[ "${result}" == "0" ]]; then
728                 # Trap unreservation before cleanup check,
729                 # so multiple jobs showing failed cleanup improve chances
730                 # of humans to notice and fix.
731                 WORKING_TOPOLOGY="${topo}"
732                 echo "Reserved: ${WORKING_TOPOLOGY}"
733                 trap "untrap_and_unreserve_testbed" EXIT || {
734                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
735                     untrap_and_unreserve_testbed "${message}" || {
736                         die "Teardown should have died, not failed."
737                     }
738                     die "Trap attempt failed, unreserve succeeded. Aborting."
739                 }
740                 # Cleanup + calibration checks
741                 set +e
742                 ansible_playbook "cleanup, calibration"
743                 result="$?"
744                 set -e
745                 if [[ "${result}" == "0" ]]; then
746                     break
747                 fi
748                 warn "Testbed cleanup failed: ${topo}"
749                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
750             fi
751             # Else testbed is accessible but currently reserved, moving on.
752         done
753
754         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
755             # Exit the infinite while loop if we made a reservation.
756             warn "Reservation and cleanup successful."
757             break
758         fi
759
760         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
761             die "Run out of operational testbeds!"
762         fi
763
764         # Wait ~3minutes before next try.
765         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
766             die "Sleep time calculation failed."
767         }
768         echo "Sleeping ${sleep_time}"
769         sleep "${sleep_time}" || die "Sleep failed."
770     done
771 }
772
773
774 function run_robot () {
775
776     # Run robot with options based on input variables.
777     #
778     # Variables read:
779     # - CSIT_DIR - Path to existing root of local CSIT git repository.
780     # - ARCHIVE_DIR - Path to store robot result files in.
781     # - ROBOT_ARGS, EXPANDED_TAGS - See compose_robot_arguments.sh
782     # - GENERATED_DIR - Tests are assumed to be generated under there.
783     # Variables set:
784     # - ROBOT_EXIT_STATUS - Exit status of most recent robot invocation.
785     # Functions called:
786     # - die - Print to stderr and exit.
787
788     set -exuo pipefail
789
790     all_options=("--outputdir" "${ARCHIVE_DIR}" "${ROBOT_ARGS[@]}")
791     all_options+=("${EXPANDED_TAGS[@]}")
792
793     pushd "${CSIT_DIR}" || die "Change directory operation failed."
794     set +e
795     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
796     ROBOT_EXIT_STATUS="$?"
797     set -e
798
799     popd || die "Change directory operation failed."
800 }
801
802
803 function select_arch_os () {
804
805     # Set variables affected by local CPU architecture and operating system.
806     #
807     # Variables set:
808     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
809     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
810     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
811
812     set -exuo pipefail
813
814     source /etc/os-release || die "Get OS release failed."
815
816     case "${ID}" in
817         "ubuntu"*)
818             case "${VERSION}" in
819                 *"LTS (Jammy Jellyfish)"*)
820                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU_JAMMY"
821                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_JAMMY"
822                     PKG_SUFFIX="deb"
823                     ;;
824                 *)
825                     die "Unsupported Ubuntu version!"
826                     ;;
827             esac
828             ;;
829         *)
830             die "Unsupported distro or OS!"
831             ;;
832     esac
833
834     arch=$(uname -m) || {
835         die "Get CPU architecture failed."
836     }
837
838     case "${arch}" in
839         "aarch64")
840             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
841             ;;
842         *)
843             ;;
844     esac
845 }
846
847
848 function select_tags () {
849
850     # Variables read:
851     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
852     # - TEST_CODE - String affecting test selection, usually jenkins job name.
853     # - DUT - CSIT test/ subdirectory, set while processing tags.
854     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
855     #   Can be unset.
856     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
857     # - BASH_FUNCTION_DIR - Directory with input files to process.
858     # Variables set:
859     # - TAGS - Array of processed tag boolean expressions.
860     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
861
862     set -exuo pipefail
863
864     # NIC SELECTION
865     case "${TEST_CODE}" in
866         *"1n-aws"* | *"1n-c6gn"* | *"1n-c6in"*)
867             start_pattern='^  SUT:'
868             ;;
869         *)
870             start_pattern='^  TG:'
871             ;;
872     esac
873     end_pattern='^ \? \?[A-Za-z0-9]\+:'
874     # Remove the sections from topology file
875     sed_command="/${start_pattern}/,/${end_pattern}/d"
876     # All topologies NICs
877     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
878                 | grep -hoP "model: \K.*" | sort -u)
879     # Selected topology NICs
880     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
881                | grep -hoP "model: \K.*" | sort -u)
882     # All topologies NICs - Selected topology NICs
883     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
884         die "Computation of excluded NICs failed."
885     }
886
887     # Select default NIC tag.
888     case "${TEST_CODE}" in
889         *"3n-snr"*)
890             default_nic="nic_intel-e822cq"
891             ;;
892         *"3n-tsh"*)
893             default_nic="nic_intel-x520-da2"
894             ;;
895         *"3n-icx"* | *"2n-icx"*)
896             default_nic="nic_intel-e810cq"
897             ;;
898         *"3na-spr"*)
899             default_nic="nic_mellanox-cx7veat"
900             ;;
901         *"3nb-spr"*)
902             default_nic="nic_intel-e810cq"
903             ;;
904         *"2n-spr"*)
905             default_nic="nic_intel-e810cq"
906             ;;
907         *"2n-clx"* | *"2n-zn2"*)
908             default_nic="nic_intel-xxv710"
909             ;;
910         *"2n-tx2"* | *"3n-alt"*)
911             default_nic="nic_intel-xl710"
912             ;;
913         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
914             default_nic="nic_amazon-nitro-50g"
915             ;;
916         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
917             default_nic="nic_amazon-nitro-100g"
918             ;;
919         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
920             default_nic="nic_amazon-nitro-200g"
921             ;;
922         *)
923             default_nic="nic_intel-x710"
924             ;;
925     esac
926
927     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
928     awk_nics_sub_cmd=""
929     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
930     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
931     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
932     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
933     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
934     awk_nics_sub_cmd+='gsub("cx7veat","200ge2p1cx7veat");'
935     awk_nics_sub_cmd+='gsub("cx6dx","100ge2p1cx6dx");'
936     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
937     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
938     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
939     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
940     awk_nics_sub_cmd+='gsub("nitro-100g","100ge1p1ENA");'
941     awk_nics_sub_cmd+='gsub("nitro-200g","200ge1p1ENA");'
942     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
943     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
944     awk_nics_sub_cmd+='else if ($9 =="drv_mlx5_core") drv ="mlx5-";'
945     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
946     awk_nics_sub_cmd+='else drv="";'
947     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
948     awk_nics_sub_cmd+='else cores=$1;'
949     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
950
951     # Tag file directory shorthand.
952     tfd="${JOB_SPECS_DIR}"
953     case "${TEST_CODE}" in
954         # Select specific performance tests based on jenkins job type variable.
955         *"device"* )
956             readarray -t test_tag_array <<< $(grep -v "#" \
957                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
958                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
959             SELECTION_MODE="--test"
960             ;;
961         *"hoststack-daily"* )
962             readarray -t test_tag_array <<< $(grep -v "#" \
963                 ${tfd}/hoststack_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
964                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
965             SELECTION_MODE="--test"
966             ;;
967         *"ndrpdr-weekly"* )
968             readarray -t test_tag_array <<< $(grep -v "#" \
969                 ${tfd}/ndrpdr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
970                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
971             SELECTION_MODE="--test"
972             ;;
973         *"mrr-daily"* )
974             readarray -t test_tag_array <<< $(grep -v "#" \
975                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
976                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
977             SELECTION_MODE="--test"
978             ;;
979         *"mrr-weekly"* )
980             readarray -t test_tag_array <<< $(grep -v "#" \
981                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
982                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
983             SELECTION_MODE="--test"
984             ;;
985         *"report-iterative"* )
986             test_sets=(${TEST_TAG_STRING//:/ })
987             # Run only one test set per run
988             report_file=${test_sets[0]}.md
989             readarray -t test_tag_array <<< $(grep -v "#" \
990                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
991                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
992             SELECTION_MODE="--test"
993             ;;
994         *"report-coverage"* )
995             test_sets=(${TEST_TAG_STRING//:/ })
996             # Run only one test set per run
997             report_file=${test_sets[0]}.md
998             readarray -t test_tag_array <<< $(grep -v "#" \
999                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
1000                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1001             SELECTION_MODE="--test"
1002             ;;
1003         * )
1004             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1005                 # If nothing is specified, we will run pre-selected tests by
1006                 # following tags.
1007                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
1008                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
1009                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
1010                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
1011                                 "!drv_af_xdp" "!drv_avf")
1012             else
1013                 # If trigger contains tags, split them into array.
1014                 test_tag_array=(${TEST_TAG_STRING//:/ })
1015             fi
1016             SELECTION_MODE="--include"
1017             ;;
1018     esac
1019
1020     # Blacklisting certain tags per topology.
1021     #
1022     # Reasons for blacklisting:
1023     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
1024     case "${TEST_CODE}" in
1025         *"1n-vbox"*)
1026             test_tag_array+=("!avf")
1027             test_tag_array+=("!vhost")
1028             test_tag_array+=("!flow")
1029             ;;
1030         *"1n_tx2"*)
1031             test_tag_array+=("!flow")
1032             ;;
1033         *"2n-clx"*)
1034             test_tag_array+=("!ipsechw")
1035             ;;
1036         *"2n-icx"*)
1037             test_tag_array+=("!ipsechw")
1038             ;;
1039         *"2n-spr"*)
1040             test_tag_array+=("!ipsechw")
1041             ;;
1042         *"2n-tx2"*)
1043             test_tag_array+=("!ipsechw")
1044             ;;
1045         *"2n-zn2"*)
1046             test_tag_array+=("!ipsechw")
1047             ;;
1048         *"3n-alt"*)
1049             test_tag_array+=("!ipsechw")
1050             ;;
1051         *"3n-icx"*)
1052             test_tag_array+=("!ipsechw")
1053             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
1054             ;;
1055         *"3n-snr"*)
1056             ;;
1057         *"3na-spr"*)
1058             test_tag_array+=("!ipsechw")
1059             ;;
1060         *"3nb-spr"*)
1061             test_tag_array+=("!ipsechw")
1062             ;;
1063         *"3n-tsh"*)
1064             test_tag_array+=("!drv_avf")
1065             test_tag_array+=("!ipsechw")
1066             ;;
1067         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1068             test_tag_array+=("!ipsechw")
1069             ;;
1070         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1071             test_tag_array+=("!ipsechw")
1072             ;;
1073         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1074             test_tag_array+=("!ipsechw")
1075             ;;
1076     esac
1077
1078     # We will add excluded NICs.
1079     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1080
1081     TAGS=()
1082     prefix=""
1083     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1084         if [[ "${TEST_CODE}" != *"device"* ]]; then
1085             # Automatic prefixing for VPP perf jobs to limit the NIC used.
1086             if [[ "${TEST_TAG_STRING-}" != *"nic_"* ]]; then
1087                 prefix="${default_nic}AND"
1088             fi
1089         fi
1090     fi
1091     set +x
1092     for tag in "${test_tag_array[@]}"; do
1093         if [[ "${tag}" == "!"* ]]; then
1094             # Exclude tags are not prefixed.
1095             TAGS+=("${tag}")
1096         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1097             # Badly formed tag expressions can trigger way too much tests.
1098             set -x
1099             warn "The following tag expression hints at bad trigger: ${tag}"
1100             warn "Possible cause: Multiple triggers in a single comment."
1101             die "Aborting to avoid triggering too many tests."
1102         elif [[ "${tag}" == *"OR"* ]]; then
1103             # If OR had higher precedence than AND, it would be useful here.
1104             # Some people think it does, thus triggering way too much tests.
1105             set -x
1106             warn "The following tag expression hints at bad trigger: ${tag}"
1107             warn "Operator OR has lower precedence than AND. Use space instead."
1108             die "Aborting to avoid triggering too many tests."
1109         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1110             # Empty and comment lines are skipped.
1111             # Other lines are normal tags, they are to be prefixed.
1112             TAGS+=("${prefix}${tag}")
1113         fi
1114     done
1115     set -x
1116 }
1117
1118
1119 function select_topology () {
1120
1121     # Variables read:
1122     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1123     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1124     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1125     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1126     # Variables set:
1127     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1128     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1129     # Functions called:
1130     # - die - Print to stderr and exit.
1131
1132     set -exuo pipefail
1133
1134     case_text="${NODENESS}_${FLAVOR}"
1135     case "${case_text}" in
1136         "1n_vbox")
1137             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1138             TOPOLOGIES_TAGS="2_node_single_link_topo"
1139             ;;
1140         "1n_skx" | "1n_tx2" | "1n_spr")
1141             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1142             TOPOLOGIES_TAGS="2_node_single_link_topo"
1143             ;;
1144         "2n_skx")
1145             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1146             TOPOLOGIES_TAGS="2_node_*_link_topo"
1147             ;;
1148         "2n_zn2")
1149             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1150             TOPOLOGIES_TAGS="2_node_*_link_topo"
1151             ;;
1152         "3n_skx")
1153             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1154             TOPOLOGIES_TAGS="3_node_*_link_topo"
1155             ;;
1156         "3n_icx")
1157             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx*.yaml )
1158             TOPOLOGIES_TAGS="3_node_*_link_topo"
1159             ;;
1160         "3na_spr")
1161             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3na_spr*.yaml )
1162             TOPOLOGIES_TAGS="3_node_*_link_topo"
1163             ;;
1164         "3nb_spr")
1165             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3nb_spr*.yaml )
1166             TOPOLOGIES_TAGS="3_node_*_link_topo"
1167             ;;
1168         "2n_clx")
1169             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1170             TOPOLOGIES_TAGS="2_node_*_link_topo"
1171             ;;
1172         "2n_icx")
1173             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx*.yaml )
1174             TOPOLOGIES_TAGS="2_node_*_link_topo"
1175             ;;
1176         "2n_spr")
1177             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_spr*.yaml )
1178             TOPOLOGIES_TAGS="2_node_*_link_topo"
1179             ;;
1180         "3n_snr")
1181             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_snr*.yaml )
1182             TOPOLOGIES_TAGS="3_node_single_link_topo"
1183             ;;
1184         "3n_tsh")
1185             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1186             TOPOLOGIES_TAGS="3_node_single_link_topo"
1187             ;;
1188         "2n_tx2")
1189             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1190             TOPOLOGIES_TAGS="2_node_single_link_topo"
1191             ;;
1192         "3n_alt")
1193             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_alt*.yaml )
1194             TOPOLOGIES_TAGS="3_node_single_link_topo"
1195             ;;
1196         "1n_aws")
1197             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-aws*.yaml )
1198             TOPOLOGIES_TAGS="1_node_single_link_topo"
1199             ;;
1200         "2n_aws")
1201             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
1202             TOPOLOGIES_TAGS="2_node_single_link_topo"
1203             ;;
1204         "3n_aws")
1205             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
1206             TOPOLOGIES_TAGS="3_node_single_link_topo"
1207             ;;
1208         "1n_c6gn")
1209             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6gn*.yaml )
1210             TOPOLOGIES_TAGS="1_node_single_link_topo"
1211             ;;
1212         "2n_c6gn")
1213             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6gn*.yaml )
1214             TOPOLOGIES_TAGS="2_node_single_link_topo"
1215             ;;
1216         "3n_c6gn")
1217             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6gn*.yaml )
1218             TOPOLOGIES_TAGS="3_node_single_link_topo"
1219             ;;
1220         "1n_c6in")
1221             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6in*.yaml )
1222             TOPOLOGIES_TAGS="1_node_single_link_topo"
1223             ;;
1224         "2n_c6in")
1225             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6in*.yaml )
1226             TOPOLOGIES_TAGS="2_node_single_link_topo"
1227             ;;
1228         "3n_c6in")
1229             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6in*.yaml )
1230             TOPOLOGIES_TAGS="3_node_single_link_topo"
1231             ;;
1232         *)
1233             # No falling back to default, that should have been done
1234             # by the function which has set NODENESS and FLAVOR.
1235             die "Unknown specification: ${case_text}"
1236     esac
1237
1238     if [[ -z "${TOPOLOGIES-}" ]]; then
1239         die "No applicable topology found!"
1240     fi
1241 }
1242
1243
1244 function set_environment_variables () {
1245
1246     # Depending on testbed topology, overwrite defaults set in the
1247     # resources/libraries/python/Constants.py file
1248     #
1249     # Variables read:
1250     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1251     # Variables set:
1252     # See specific cases
1253
1254     set -exuo pipefail
1255
1256     case "${TEST_CODE}" in
1257         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1258             export TREX_RX_DESCRIPTORS_COUNT=1024
1259             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1260             export TREX_CORE_COUNT=6
1261             # Settings to prevent duration stretching.
1262             export PERF_TRIAL_STL_DELAY=0.1
1263             ;;
1264         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1265             export TREX_RX_DESCRIPTORS_COUNT=1024
1266             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1267             export TREX_CORE_COUNT=6
1268             # Settings to prevent duration stretching.
1269             export PERF_TRIAL_STL_DELAY=0.1
1270             ;;
1271         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1272             export TREX_RX_DESCRIPTORS_COUNT=1024
1273             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1274             export TREX_CORE_COUNT=6
1275             # Settings to prevent duration stretching.
1276             export PERF_TRIAL_STL_DELAY=0.1
1277             ;;
1278         *"2n-zn2"*)
1279             # Maciek's workaround for Zen2 with lower amount of cores.
1280             export TREX_CORE_COUNT=14
1281     esac
1282 }
1283
1284
1285 function untrap_and_unreserve_testbed () {
1286
1287     # Use this as a trap function to ensure testbed does not remain reserved.
1288     # Perhaps call directly before script exit, to free testbed for other jobs.
1289     # This function is smart enough to avoid multiple unreservations (so safe).
1290     # Topo cleanup is executed (call it best practice), ignoring failures.
1291     #
1292     # Hardcoded values:
1293     # - default message to die with if testbed might remain reserved.
1294     # Arguments:
1295     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1296     # Variables read (by inner function):
1297     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1298     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1299     # Variables set:
1300     # - TERRAFORM_MODULE_DIR - Terraform module directory.
1301     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1302     # Trap unregistered:
1303     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1304     # Functions called:
1305     # - die - Print to stderr and exit.
1306     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1307
1308     set -xo pipefail
1309     set +eu  # We do not want to exit early in a "teardown" function.
1310     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1311     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1312     if [[ -z "${wt-}" ]]; then
1313         set -eu
1314         warn "Testbed looks unreserved already. Trap removal failed before?"
1315     else
1316         ansible_playbook "cleanup" || true
1317         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1318             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1319         }
1320         case "${TEST_CODE}" in
1321             *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1322                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
1323                 terraform_destroy || die "Failed to call terraform destroy."
1324                 ;;
1325             *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1326                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1327                 terraform_destroy || die "Failed to call terraform destroy."
1328                 ;;
1329             *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1330                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1331                 terraform_destroy || die "Failed to call terraform destroy."
1332                 ;;
1333             *)
1334                 ;;
1335         esac
1336         WORKING_TOPOLOGY=""
1337         set -eu
1338     fi
1339 }
1340
1341
1342 function warn () {
1343
1344     # Print the message to standard error.
1345     #
1346     # Arguments:
1347     # - ${@} - The text of the message.
1348
1349     set -exuo pipefail
1350
1351     echo "$@" >&2
1352 }